"""
Sprout
Copyright(C), 2005, Enfold Systems, LLC - ALL RIGHTS RESERVED

This software is licensed under the Terms and Conditions contained
within the License.txt file that accompanied this software.  Any inquiries
concerning the scope or enforceability of the license should be addressed to:

Enfold Systems, LLC
4617 Montrose Blvd., Suite C215
Houston, Texas 77006 USA
p. +1 713.942.2377 | f. +1 832.201.8856
www.enfoldsystems.com
info@enfoldsystems.com

$Id: Install.py 1312 2005-08-31 19:57:48Z jlaplace $
"""

from cStringIO import StringIO

from Products.Archetypes.Extensions.utils import install_subskin
from Products.CMFCore.utils import getToolByName

from Products.Sprout.config import *

NEW_PROPS = (
             ('name','Navigation', 'string'),
             ('root', '/', 'string'),
             ('appearAtLevel', 0, 'int'),
            )

def install_props(self, out):
    out.write("Adding new properties:\n")
    proptool = getToolByName(self, 'portal_properties')
    propsheet = proptool.navtree_properties
    for prop, value, type in NEW_PROPS:
        out.write("...")
        if not propsheet.hasProperty(prop):
           propsheet.manage_addProperty(prop, value, type)
           out.write("%s\n" % prop)
        else:
           out.write("%s (exists, left unchanged)\n" % prop)
    
    out.write("Changing property 'bottomLevel': ")
    if propsheet.getProperty('bottomLevel') == 65535:
       propsheet.manage_changeProperties(bottomLevel=0)
       out.write("default reset to 0")
    else:
       out.write("non-default value left alone")
    out.write(".\n")

    out.write("Done\n")

def install(self, out=None):
    if out is None:
        out = StringIO()
    install_subskin(self, out, GLOBALS)
    install_props(self, out)
    return out.getvalue()
