## NOTE: this code should closely follow the patch section in 'plonetool.py'

from Products.CMFCore.utils import getToolByName

props = getToolByName(context, 'portal_properties').navtree_properties
proproot = props.getProperty('root')
startContext = proproot == '.'

portal_url = getToolByName(context, 'portal_url')
portal = portal_url.getPortalObject()
if startContext:
    rt = context
    if not rt.isPrincipiaFolderish:
        rt = context.aq_parent
    return {'title': rt.Title(),
            'description': rt.Description(),
            'url': rt.absolute_url(),
            }
elif len(proproot) > 1 and proproot[0]=='/':
    ppath = getToolByName(context, 'portal_url').getPortalPath()
    ppath = ''.join([ppath, proproot])
    try:
        rt = context.restrictedTraverse(ppath)
        return {'title': rt.Title(),
                'description': rt.Description(),
                'url': rt.absolute_url(),
                }
    except AttributeError:
        pass
    except KeyError:
        pass

return {'title': 'Home',
        'description': portal.Description(),
        'url': portal_url(),
        }
